<?php

declare(strict_types=1);

namespace App\Repository;

final class PreguntasFrecuentesRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $PreguntasFrecuentesId): object
    {
        $query = 'SELECT * FROM `PreguntasFrecuentes` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $PreguntasFrecuentesId);
        $statement->execute();
        $PreguntasFrecuentes = $statement->fetchObject();
        if (! $PreguntasFrecuentes) {
            throw new \Exception('PreguntasFrecuentes not found.', 404);
        }

        return $PreguntasFrecuentes;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `PreguntasFrecuentes` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $PreguntasFrecuentes): object
    {
        $query = 'INSERT INTO `PreguntasFrecuentes` (`Pregunta`, `Respuesta`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Pregunta, :Respuesta, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $PreguntasFrecuentes->id);
//         $statement->bindParam('fecha', $PreguntasFrecuentes->fecha);
        $statement->bindParam('Pregunta', $PreguntasFrecuentes->Pregunta);
        $statement->bindParam('Respuesta', $PreguntasFrecuentes->Respuesta);
        $statement->bindParam('field1', $PreguntasFrecuentes->field1);
        $statement->bindParam('field2', $PreguntasFrecuentes->field2);
        $statement->bindParam('field3', $PreguntasFrecuentes->field3);
        $statement->bindParam('field4', $PreguntasFrecuentes->field4);
        $statement->bindParam('field5', $PreguntasFrecuentes->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $PreguntasFrecuentes, object $data): object
    {
        if (isset($data->fecha)) {
            $PreguntasFrecuentes->fecha = $data->fecha;
        }
        if (isset($data->Pregunta)) {
            $PreguntasFrecuentes->Pregunta = $data->Pregunta;
        }
        if (isset($data->Respuesta)) {
            $PreguntasFrecuentes->Respuesta = $data->Respuesta;
        }
        if (isset($data->field1)) {
            $PreguntasFrecuentes->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $PreguntasFrecuentes->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $PreguntasFrecuentes->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $PreguntasFrecuentes->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $PreguntasFrecuentes->field5 = $data->field5;
        }

        $query = 'UPDATE `PreguntasFrecuentes` SET `fecha` = :fecha, `Pregunta` = :Pregunta, `Respuesta` = :Respuesta, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $PreguntasFrecuentes->id);
        $statement->bindParam('fecha', $PreguntasFrecuentes->fecha);
        $statement->bindParam('Pregunta', $PreguntasFrecuentes->Pregunta);
        $statement->bindParam('Respuesta', $PreguntasFrecuentes->Respuesta);
        $statement->bindParam('field1', $PreguntasFrecuentes->field1);
        $statement->bindParam('field2', $PreguntasFrecuentes->field2);
        $statement->bindParam('field3', $PreguntasFrecuentes->field3);
        $statement->bindParam('field4', $PreguntasFrecuentes->field4);
        $statement->bindParam('field5', $PreguntasFrecuentes->field5);

        $statement->execute();

        return $this->checkAndGet((int) $PreguntasFrecuentes->id);
    }

    public function delete(int $PreguntasFrecuentesId): void
    {
        $query = 'DELETE FROM `PreguntasFrecuentes` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $PreguntasFrecuentesId);
        $statement->execute();
    }
}
